Index: trunk/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/StructureTemplate/StructureTemplateView.Designer.cs
===================================================================
--- trunk/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/StructureTemplate/StructureTemplateView.Designer.cs	(revision 18220)
+++ trunk/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/StructureTemplate/StructureTemplateView.Designer.cs	(revision 18220)
@@ -0,0 +1,202 @@
+﻿
+using System.Drawing;
+using System.Windows.Forms;
+
+namespace HeuristicLab.Problems.DataAnalysis.Symbolic.Views {
+  partial class StructureTemplateView {
+    
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.components = new System.ComponentModel.Container();
+      System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(StructureTemplateView));
+      this.detailsGroupBox = new System.Windows.Forms.GroupBox();
+      this.viewHost = new HeuristicLab.MainForm.WindowsForms.ViewHost();
+      this.templateStructureGroupBox = new System.Windows.Forms.GroupBox();
+      this.linearScalingCheckBox = new System.Windows.Forms.CheckBox();
+      this.infoLabel = new System.Windows.Forms.Label();
+      this.treeChart = new HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views.SymbolicExpressionTreeChart();
+      this.parseButton = new System.Windows.Forms.Button();
+      this.expressionInput = new System.Windows.Forms.TextBox();
+      this.splitContainer = new System.Windows.Forms.SplitContainer();
+      this.toolTip = new System.Windows.Forms.ToolTip(this.components);
+      this.errorLabel = new System.Windows.Forms.Label();
+      this.detailsGroupBox.SuspendLayout();
+      this.templateStructureGroupBox.SuspendLayout();
+      ((System.ComponentModel.ISupportInitialize)(this.splitContainer)).BeginInit();
+      this.splitContainer.Panel1.SuspendLayout();
+      this.splitContainer.Panel2.SuspendLayout();
+      this.splitContainer.SuspendLayout();
+      this.SuspendLayout();
+      // 
+      // detailsGroupBox
+      // 
+      this.detailsGroupBox.Controls.Add(this.viewHost);
+      this.detailsGroupBox.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.detailsGroupBox.Location = new System.Drawing.Point(0, 0);
+      this.detailsGroupBox.Name = "detailsGroupBox";
+      this.detailsGroupBox.Size = new System.Drawing.Size(296, 400);
+      this.detailsGroupBox.TabIndex = 9;
+      this.detailsGroupBox.TabStop = false;
+      this.detailsGroupBox.Text = "Details";
+      // 
+      // viewHost
+      // 
+      this.viewHost.Caption = "View";
+      this.viewHost.Content = null;
+      this.viewHost.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.viewHost.Enabled = false;
+      this.viewHost.Location = new System.Drawing.Point(3, 16);
+      this.viewHost.Name = "viewHost";
+      this.viewHost.ReadOnly = false;
+      this.viewHost.Size = new System.Drawing.Size(290, 381);
+      this.viewHost.TabIndex = 8;
+      this.viewHost.ViewsLabelVisible = true;
+      this.viewHost.ViewType = null;
+      // 
+      // templateStructureGroupBox
+      // 
+      this.templateStructureGroupBox.Controls.Add(this.errorLabel);
+      this.templateStructureGroupBox.Controls.Add(this.linearScalingCheckBox);
+      this.templateStructureGroupBox.Controls.Add(this.infoLabel);
+      this.templateStructureGroupBox.Controls.Add(this.treeChart);
+      this.templateStructureGroupBox.Controls.Add(this.parseButton);
+      this.templateStructureGroupBox.Controls.Add(this.expressionInput);
+      this.templateStructureGroupBox.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.templateStructureGroupBox.Location = new System.Drawing.Point(0, 0);
+      this.templateStructureGroupBox.Name = "templateStructureGroupBox";
+      this.templateStructureGroupBox.Size = new System.Drawing.Size(300, 400);
+      this.templateStructureGroupBox.TabIndex = 8;
+      this.templateStructureGroupBox.TabStop = false;
+      this.templateStructureGroupBox.Text = "Template Structure";
+      // 
+      // linearScalingCheckBox
+      // 
+      this.linearScalingCheckBox.AutoSize = true;
+      this.linearScalingCheckBox.Location = new System.Drawing.Point(149, 49);
+      this.linearScalingCheckBox.Name = "linearScalingCheckBox";
+      this.linearScalingCheckBox.Size = new System.Drawing.Size(122, 17);
+      this.linearScalingCheckBox.TabIndex = 8;
+      this.linearScalingCheckBox.Text = "Apply Linear Scaling";
+      this.linearScalingCheckBox.UseVisualStyleBackColor = true;
+      this.linearScalingCheckBox.CheckStateChanged += new System.EventHandler(this.LinearScalingCheckBoxCheckStateChanged);
+      // 
+      // infoLabel
+      // 
+      this.infoLabel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
+      this.infoLabel.BackColor = System.Drawing.Color.White;
+      this.infoLabel.Image = HeuristicLab.Common.Resources.VSImageLibrary.Information;
+      this.infoLabel.Location = new System.Drawing.Point(275, 22);
+      this.infoLabel.Name = "infoLabel";
+      this.infoLabel.Size = new System.Drawing.Size(15, 15);
+      this.infoLabel.TabIndex = 4;
+      this.infoLabel.Text = "    ";
+      this.toolTip.SetToolTip(this.infoLabel, "Double-click to open description.");
+      this.infoLabel.DoubleClick += new System.EventHandler(this.HelpButtonDoubleClick);
+      // 
+      // treeChart
+      // 
+      this.treeChart.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.treeChart.BackgroundColor = System.Drawing.Color.White;
+      this.treeChart.LineColor = System.Drawing.Color.Black;
+      this.treeChart.Location = new System.Drawing.Point(3, 74);
+      this.treeChart.MinimumHorizontalDistance = 30;
+      this.treeChart.MinimumHorizontalPadding = 20;
+      this.treeChart.MinimumVerticalDistance = 30;
+      this.treeChart.MinimumVerticalPadding = 20;
+      this.treeChart.Name = "treeChart";
+      this.treeChart.PreferredNodeHeight = 46;
+      this.treeChart.PreferredNodeWidth = 70;
+      this.treeChart.Size = new System.Drawing.Size(291, 320);
+      this.treeChart.SuspendRepaint = false;
+      this.treeChart.TabIndex = 7;
+      this.treeChart.TextFont = new System.Drawing.Font("Times New Roman", 8F);
+      this.treeChart.Tree = null;
+      // 
+      // parseButton
+      // 
+      this.parseButton.Location = new System.Drawing.Point(3, 45);
+      this.parseButton.Name = "parseButton";
+      this.parseButton.Size = new System.Drawing.Size(140, 23);
+      this.parseButton.TabIndex = 3;
+      this.parseButton.Text = "Parse";
+      this.parseButton.UseVisualStyleBackColor = true;
+      this.parseButton.Click += new System.EventHandler(this.ParseButtonClick);
+      // 
+      // expressionInput
+      // 
+      this.expressionInput.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.expressionInput.Location = new System.Drawing.Point(3, 19);
+      this.expressionInput.Name = "expressionInput";
+      this.expressionInput.Size = new System.Drawing.Size(266, 20);
+      this.expressionInput.TabIndex = 1;
+      this.expressionInput.TextChanged += new System.EventHandler(this.ExpressionInputTextChanged);
+      this.expressionInput.KeyUp += new System.Windows.Forms.KeyEventHandler(this.ExpressionInputKeyUp);
+      // 
+      // splitContainer
+      // 
+      this.splitContainer.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.splitContainer.Location = new System.Drawing.Point(0, 0);
+      this.splitContainer.Margin = new System.Windows.Forms.Padding(0);
+      this.splitContainer.Name = "splitContainer";
+      // 
+      // splitContainer.Panel1
+      // 
+      this.splitContainer.Panel1.Controls.Add(this.templateStructureGroupBox);
+      this.splitContainer.Panel1MinSize = 5;
+      // 
+      // splitContainer.Panel2
+      // 
+      this.splitContainer.Panel2.Controls.Add(this.detailsGroupBox);
+      this.splitContainer.Panel2MinSize = 5;
+      this.splitContainer.Size = new System.Drawing.Size(600, 400);
+      this.splitContainer.SplitterDistance = 300;
+      this.splitContainer.TabIndex = 10;
+      // 
+      // errorLabel
+      // 
+      this.errorLabel.AutoSize = true;
+      this.errorLabel.BackColor = System.Drawing.Color.White;
+      this.errorLabel.Location = new System.Drawing.Point(3, 74);
+      this.errorLabel.Name = "errorLabel";
+      this.errorLabel.Size = new System.Drawing.Size(0, 13);
+      this.errorLabel.TabIndex = 9;
+      // 
+      // StructureTemplateView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.splitContainer);
+      this.Name = "StructureTemplateView";
+      this.Size = new System.Drawing.Size(600, 400);
+      this.detailsGroupBox.ResumeLayout(false);
+      this.templateStructureGroupBox.ResumeLayout(false);
+      this.templateStructureGroupBox.PerformLayout();
+      this.splitContainer.Panel1.ResumeLayout(false);
+      this.splitContainer.Panel2.ResumeLayout(false);
+      ((System.ComponentModel.ISupportInitialize)(this.splitContainer)).EndInit();
+      this.splitContainer.ResumeLayout(false);
+      this.ResumeLayout(false);
+
+    }
+
+
+    private System.Windows.Forms.GroupBox detailsGroupBox;
+    private MainForm.WindowsForms.ViewHost viewHost;
+    private System.Windows.Forms.GroupBox templateStructureGroupBox;
+    private System.Windows.Forms.CheckBox linearScalingCheckBox;
+    private System.Windows.Forms.Label infoLabel;
+    private Encodings.SymbolicExpressionTreeEncoding.Views.SymbolicExpressionTreeChart treeChart;
+    private System.Windows.Forms.Button parseButton;
+    private System.Windows.Forms.TextBox expressionInput;
+    private System.Windows.Forms.SplitContainer splitContainer;
+    private System.ComponentModel.IContainer components;
+    private ToolTip toolTip;
+    private Label errorLabel;
+  }
+}
Index: trunk/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/StructureTemplate/StructureTemplateView.cs
===================================================================
--- trunk/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/StructureTemplate/StructureTemplateView.cs	(revision 18220)
+++ trunk/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/StructureTemplate/StructureTemplateView.cs	(revision 18220)
@@ -0,0 +1,126 @@
+﻿ using System;
+using System.Collections.Generic;
+using System.Drawing;
+using System.Linq;
+using System.Text;
+using System.Windows.Forms;
+using HeuristicLab.Collections;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views;
+using HeuristicLab.MainForm;
+using HeuristicLab.MainForm.WindowsForms;
+
+namespace HeuristicLab.Problems.DataAnalysis.Symbolic.Views {
+
+  [View("StructureTemplate View")]
+  [Content(typeof(StructureTemplate), true)]
+  public partial class StructureTemplateView : AsynchronousContentView {
+    public new StructureTemplate Content {
+      get => (StructureTemplate)base.Content;
+      set => base.Content = value;
+    }
+
+    public StructureTemplateView() {
+      InitializeComponent();
+      errorLabel.Text = "";
+      this.Resize += StructureTemplateViewResize;
+      splitContainer.SplitterMoved += SplitContainerSplitterMoved;
+      treeChart.SymbolicExpressionTreeNodeClicked += SymbolicExpressionTreeNodeClicked;
+      
+    }
+
+    private void SplitContainerSplitterMoved(object sender, EventArgs e) {
+      PaintTree();
+    }
+
+    private void StructureTemplateViewResize(object sender, EventArgs e) {
+      PaintTree();
+    }
+
+    private void SymbolicExpressionTreeNodeClicked(object sender, MouseEventArgs e) {
+      var visualTreeNode = sender as VisualTreeNode<ISymbolicExpressionTreeNode>;
+      if(visualTreeNode != null && visualTreeNode.Content is SubFunctionTreeNode subFunctionTreeNode) {
+        var selectedSubFunction = Content.SubFunctions.Where(x => x.Name == subFunctionTreeNode.Name).FirstOrDefault();
+        if(subFunctionTreeNode != null && selectedSubFunction != null)
+          viewHost.Content = selectedSubFunction;
+      }
+    }
+
+    protected override void SetEnabledStateOfControls() {
+      base.SetEnabledStateOfControls();
+      parseButton.Enabled = Content != null && !Locked && !ReadOnly;
+      linearScalingCheckBox.Enabled = Content != null && !Locked && !ReadOnly;
+      expressionInput.Enabled = Content != null && !Locked && !ReadOnly;
+    }
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      if (Content == null) return;
+      expressionInput.Text = Content.Template;
+      linearScalingCheckBox.Checked = Content.ApplyLinearScaling; 
+      PaintTree();
+      errorLabel.Text = "";
+    }
+
+    private void ParseButtonClick(object sender, EventArgs e) {
+      Parse();
+    }
+
+    private void ExpressionInputTextChanged(object sender, EventArgs e) {
+      errorLabel.Text = "Unparsed changes! Press parse button to save changes.";
+      errorLabel.ForeColor = Color.DarkOrange;
+    }
+
+    private void PaintTree() {
+      if(Content != null && Content.Tree != null) {
+        treeChart.Tree = Content.Tree;
+        foreach (var n in Content.Tree.IterateNodesPrefix()) {
+          if (n.Symbol is SubFunctionSymbol) {
+            var visualNode = treeChart.GetVisualSymbolicExpressionTreeNode(n);
+            visualNode.FillColor = Color.LightCyan;
+            visualNode.LineColor = Color.SlateGray;
+          }
+        }
+        treeChart.RepaintNodes();
+      }
+    }
+
+    private void ExpressionInputKeyUp(object sender, KeyEventArgs e) {
+      if (e.KeyCode == Keys.Enter)
+        Parse();
+    }
+
+    private void Parse() {
+      viewHost.Content = null; // reset active detail view
+      if (!string.IsNullOrEmpty(expressionInput.Text)) {
+        try {
+          Content.Template = expressionInput.Text;
+          PaintTree();
+          errorLabel.Text = "Template structure successfully parsed.";
+          errorLabel.ForeColor = Color.DarkGreen;
+        } catch (AggregateException ex) {
+          errorLabel.Text = string.Join("\n", ex.InnerExceptions.Select(x => x.Message));
+          errorLabel.ForeColor = Color.DarkRed;
+        } catch (Exception ex) {
+          errorLabel.Text = ex.Message;
+          errorLabel.ForeColor = Color.DarkRed;
+        }
+      }
+    }
+
+    private void LinearScalingCheckBoxCheckStateChanged(object sender, EventArgs e) {
+      Content.ApplyLinearScaling = linearScalingCheckBox.Checked;
+      PaintTree();
+    }
+
+    private void HelpButtonDoubleClick(object sender, EventArgs e) {
+      using (InfoBox dialog = new InfoBox("Help for structure template",
+        "HeuristicLab.Problems.DataAnalysis.Symbolic.Views.Resources.structureTemplateHelp.rtf",
+        this)) {
+        dialog.ShowDialog(this);
+      }
+    }
+  }
+}
Index: trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Converters/DerivativeCalculator.cs
===================================================================
--- trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Converters/DerivativeCalculator.cs	(revision 18211)
+++ trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Converters/DerivativeCalculator.cs	(revision 18220)
@@ -199,4 +199,7 @@
         var tanh = (ISymbolicExpressionTreeNode)branch.Clone();
         return Product(fxp, Subtract(CreateNumber(1.0), Square(tanh)));
+      }
+      if (branch.Symbol is SubFunctionSymbol) {
+        return Derive(branch.GetSubtree(0), variableName);
       }
       throw new NotSupportedException(string.Format("Symbol {0} is not supported.", branch.Symbol));
@@ -285,5 +288,6 @@
           !(n.Symbol is Cosine) &&
           !(n.Symbol is Tangent) &&
-          !(n.Symbol is StartSymbol)
+          !(n.Symbol is StartSymbol) &&
+          !(n.Symbol is SubFunctionSymbol)
         select n).Any();
       return !containsUnknownSymbol;
Index: trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Converters/TreeToAutoDiffTermConverter.cs
===================================================================
--- trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Converters/TreeToAutoDiffTermConverter.cs	(revision 18211)
+++ trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Converters/TreeToAutoDiffTermConverter.cs	(revision 18220)
@@ -106,6 +106,15 @@
       out ParametricFunctionGradient func_grad) {
 
+      return TryConvertToAutoDiff(tree, makeVariableWeightsVariable, addLinearScalingTerms, Enumerable.Empty<ISymbolicExpressionTreeNode>(),
+        out parameters, out initialParamValues, out func, out func_grad);
+    }
+
+    public static bool TryConvertToAutoDiff(ISymbolicExpressionTree tree, bool makeVariableWeightsVariable, bool addLinearScalingTerms, IEnumerable<ISymbolicExpressionTreeNode> excludedNodes,
+      out List<DataForVariable> parameters, out double[] initialParamValues,
+      out ParametricFunction func,
+      out ParametricFunctionGradient func_grad) {
+
       // use a transformator object which holds the state (variable list, parameter list, ...) for recursive transformation of the tree
-      var transformator = new TreeToAutoDiffTermConverter(makeVariableWeightsVariable, addLinearScalingTerms);
+      var transformator = new TreeToAutoDiffTermConverter(makeVariableWeightsVariable, addLinearScalingTerms, excludedNodes);
       AutoDiff.Term term;
       try {
@@ -134,8 +143,11 @@
     private readonly bool makeVariableWeightsVariable;
     private readonly bool addLinearScalingTerms;
-
-    private TreeToAutoDiffTermConverter(bool makeVariableWeightsVariable, bool addLinearScalingTerms) {
+    private readonly HashSet<ISymbolicExpressionTreeNode> excludedNodes;
+
+    private TreeToAutoDiffTermConverter(bool makeVariableWeightsVariable, bool addLinearScalingTerms, IEnumerable<ISymbolicExpressionTreeNode> excludedNodes) {
       this.makeVariableWeightsVariable = makeVariableWeightsVariable;
       this.addLinearScalingTerms = addLinearScalingTerms;
+      this.excludedNodes = new HashSet<ISymbolicExpressionTreeNode>(excludedNodes);
+
       this.initialParamValues = new List<double>();
       this.parameters = new Dictionary<DataForVariable, AutoDiff.Variable>();
@@ -161,5 +173,5 @@
         var par = FindOrCreateParameter(parameters, varNode.VariableName, varValue);
 
-        if (makeVariableWeightsVariable) {
+        if (makeVariableWeightsVariable && !excludedNodes.Contains(node)) {
           initialParamValues.Add(varNode.Weight);
           var w = new AutoDiff.Variable();
@@ -176,9 +188,15 @@
           var par = FindOrCreateParameter(parameters, factorVarNode.VariableName, variableValue);
 
-          initialParamValues.Add(factorVarNode.GetValue(variableValue));
-          var wVar = new AutoDiff.Variable();
-          variables.Add(wVar);
-
-          products.Add(AutoDiff.TermBuilder.Product(wVar, par));
+          if (makeVariableWeightsVariable && !excludedNodes.Contains(node)) {
+            initialParamValues.Add(factorVarNode.GetValue(variableValue));
+            var wVar = new AutoDiff.Variable();
+            variables.Add(wVar);
+
+            products.Add(AutoDiff.TermBuilder.Product(wVar, par));
+          } else {
+            var weight = factorVarNode.GetValue(variableValue);
+            products.Add(weight * par);
+          }
+
         }
         return AutoDiff.TermBuilder.Sum(products);
@@ -188,5 +206,5 @@
         var par = FindOrCreateParameter(parameters, varNode.VariableName, string.Empty, varNode.Lag);
 
-        if (makeVariableWeightsVariable) {
+        if (makeVariableWeightsVariable && !excludedNodes.Contains(node)) {
           initialParamValues.Add(varNode.Weight);
           var w = new AutoDiff.Variable();
@@ -305,4 +323,7 @@
           return t * alpha + beta;
         } else return ConvertToAutoDiff(node.GetSubtree(0));
+      }
+      if (node.Symbol is SubFunctionSymbol) {
+        return ConvertToAutoDiff(node.GetSubtree(0));
       }
       throw new ConversionException();
@@ -353,5 +374,6 @@
           !(n.Symbol is Cube) &&
           !(n.Symbol is CubeRoot) &&
-          !(n.Symbol is Power)
+          !(n.Symbol is Power) &&
+          !(n.Symbol is SubFunctionSymbol)
         select n).Any();
       return !containsUnknownSymbol;
Index: trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/InfixExpressionFormatter.cs
===================================================================
--- trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/InfixExpressionFormatter.cs	(revision 18211)
+++ trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/InfixExpressionFormatter.cs	(revision 18220)
@@ -35,4 +35,5 @@
     ///  Performs some basic re-writing steps to simplify the code for formatting. Tree is changed.
     ///  Removes single-argument +, * which have no effect
+    ///  Removes SubFunctions (no effect)
     ///  Replaces variables with coefficients by an explicitly multiplication
     ///  Replaces single-argument / with 1 / (..)
@@ -57,4 +58,6 @@
         mul.AddSubtree(num);
         mul.AddSubtree(varTreeNode);
+      } else if (n.Symbol is SubFunctionSymbol) {
+        parent.ReplaceSubtree(n, n.GetSubtree(0));
       } else if (n.SubtreeCount == 1 && (n.Symbol is Addition || n.Symbol is Multiplication || n.Symbol is And || n.Symbol is Or || n.Symbol is Xor)) {
         // single-argument addition or multiplication has no effect -> remove
@@ -81,6 +84,6 @@
         }
         parent.InsertSubtree(childIdx, newChild);
-      } else if (n.SubtreeCount == 2 && n.GetSubtree(1).SubtreeCount == 2 && 
-                 IsAssocOp(n.Symbol) && IsOperator(n.GetSubtree(1).Symbol) && 
+      } else if (n.SubtreeCount == 2 && n.GetSubtree(1).SubtreeCount == 2 &&
+                 IsAssocOp(n.Symbol) && IsOperator(n.GetSubtree(1).Symbol) &&
                  Priority(n.Symbol) == Priority(n.GetSubtree(1).Symbol)) {
         // f(x) <op> (g(x) <op> h(x))) is the same as  (f(x) <op> g(x)) <op> h(x) for associative <op>
@@ -104,6 +107,4 @@
                                           NumberFormatInfo numberFormat, string formatString, List<KeyValuePair<string, double>> parameters = null) {
       // This method assumes that the tree has been converted to binary and left-assoc form (see ConvertToBinaryLeftAssocRec). 
-      // An exception is thrown if the tree has a different shape.
-
       if (node.SubtreeCount == 0) {
         // no subtrees
Index: trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionCSharpFormatter.cs
===================================================================
--- trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionCSharpFormatter.cs	(revision 18211)
+++ trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionCSharpFormatter.cs	(revision 18220)
@@ -155,4 +155,6 @@
           FormatRecursively(node.GetSubtree(1), strBuilder);
           strBuilder.Append(" , 2) ) )");
+        } else if (node.Symbol is SubFunctionSymbol) {
+          FormatRecursively(node.GetSubtree(0), strBuilder);
         } else {
           throw new NotSupportedException("Formatting of symbol: " + node.Symbol + " not supported for C# symbolic expression tree formatter.");
Index: trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionExcelFormatter.cs
===================================================================
--- trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionExcelFormatter.cs	(revision 18211)
+++ trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionExcelFormatter.cs	(revision 18220)
@@ -310,4 +310,6 @@
         stringBuilder.Append(FormatRecursively(node.GetSubtree(1)));
         stringBuilder.Append("), 1.0, -1.0)");
+      } else if (symbol is SubFunctionSymbol) {
+        stringBuilder.Append(FormatRecursively(node.GetSubtree(0)));
       } else {
         throw new NotImplementedException("Excel export of " + node.Symbol + " is not implemented.");
Index: trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionLatexFormatter.cs
===================================================================
--- trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionLatexFormatter.cs	(revision 18211)
+++ trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionLatexFormatter.cs	(revision 18220)
@@ -279,4 +279,6 @@
         paramIdx++;
         strBuilder.Append(@" \left( " + p + @"\cdot ");
+      } else if (node.Symbol is SubFunctionSymbol) {
+        // to nothing, skip symbol
       } else {
         throw new NotImplementedException("Export of " + node.Symbol + " is not implemented.");
@@ -387,4 +389,6 @@
         paramIdx++;
         strBuilder.Append(@" +  \left( 1 - " + p + @" \right) \cdot ");
+      } else if (node.Symbol is SubFunctionSymbol) {
+        throw new InvalidOperationException();
       } else {
         throw new NotImplementedException("Export of " + node.Symbol + " is not implemented.");
@@ -511,4 +515,5 @@
       } else if (node.Symbol is VariableCondition) {
         strBuilder.Append(@"\right) ");
+      } else if (node.Symbol is SubFunctionSymbol) {
       } else {
         throw new NotImplementedException("Export of " + node.Symbol + " is not implemented.");
Index: trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionMATLABFormatter.cs
===================================================================
--- trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionMATLABFormatter.cs	(revision 18211)
+++ trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionMATLABFormatter.cs	(revision 18220)
@@ -388,4 +388,6 @@
         stringBuilder.Append(FormatRecursively(node.GetSubtree(0)));
         currentLag -= laggedNode.Lag;
+      } else if (symbol is SubFunctionSymbol) {
+        stringBuilder.Append(FormatRecursively(node.GetSubtree(0)));
       } else {
         stringBuilder.Append("ERROR");
Index: trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionMathematicaFormatter.cs
===================================================================
--- trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionMathematicaFormatter.cs	(revision 18211)
+++ trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionMathematicaFormatter.cs	(revision 18220)
@@ -122,4 +122,6 @@
         } else if (node.Symbol is Root) {
           FormatRoot(node, strBuilder);
+        } else if (node.Symbol is SubFunctionSymbol) {
+          FormatRecursively(node.GetSubtree(0), strBuilder);
         } else {
           throw new NotSupportedException("Formatting of symbol: " + node.Symbol + " is not supported.");
Index: trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionPythonFormatter.cs
===================================================================
--- trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionPythonFormatter.cs	(revision 18211)
+++ trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionPythonFormatter.cs	(revision 18220)
@@ -204,4 +204,6 @@
       else if (node is INumericTreeNode)
         FormatNumericTreeNode(node, strBuilder);
+      else if (symbol is SubFunctionSymbol)
+        FormatRecursively(node.GetSubtree(0), strBuilder);
       else
         throw new NotSupportedException("Formatting of symbol: " + symbol + " not supported for Python symbolic expression tree formatter.");
@@ -228,10 +230,6 @@
 
     private static void FormatNumericTreeNode(ISymbolicExpressionTreeNode node, StringBuilder strBuilder) {
-      var symbol = node.Symbol;
-      if (node is INumericTreeNode numNode) {
-        strBuilder.Append(numNode.Value.ToString("g17", CultureInfo.InvariantCulture));
-      } else {
-        throw new NotSupportedException("Formatting of symbol: " + symbol + " not supported for Python symbolic expression tree formatter.");
-      }
+      var numNode = node as INumericTreeNode;
+      strBuilder.Append(numNode.Value.ToString("g17", CultureInfo.InvariantCulture));
     }
 
Index: trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionSmalltalkFormatter.cs
===================================================================
--- trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionSmalltalkFormatter.cs	(revision 18211)
+++ trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionSmalltalkFormatter.cs	(revision 18220)
@@ -184,4 +184,6 @@
       } else if (symbol is BinaryFactorVariable || symbol is FactorVariable) {
         stringBuilder.Append("factor variables are not supported");
+      } else if (symbol is SubFunctionSymbol) {
+        stringBuilder.Append(FormatRecursively(node.GetSubtree(0)));
       } else {
         stringBuilder.Append("(");
Index: trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/TSQLExpressionFormatter.cs
===================================================================
--- trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/TSQLExpressionFormatter.cs	(revision 18211)
+++ trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/TSQLExpressionFormatter.cs	(revision 18220)
@@ -157,4 +157,6 @@
         } else if (node.Symbol is Root) {
           FormatRoot(level, node, strBuilder);
+        } else if (node.Symbol is SubFunctionSymbol) {
+          FormatRecursively(level, node.GetSubtree(0), strBuilder);
         } else {
           throw new NotSupportedException("Formatting of symbol: " + node.Symbol + " not supported for TSQL symbolic expression tree formatter.");
